/**
 * DevExtreme (renovation/viz/core/tooltip.js)
 * Version: 21.1.0 (build 20350-0313)
 * Build date: Tue Dec 15 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.Tooltip = Tooltip;
exports.TooltipProps = exports.viewFunction = void 0;
var _svg_path = require("./renderers/svg_path");
var _svg_text = require("./renderers/svg_text");
var _tooltip_utils = require("./common/tooltip_utils");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            default: obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter((function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            }))
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach((function(key) {
                _defineProperty(target, key, source[key])
            }))
        } else if (Object.getOwnPropertyDescriptors) {
            Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
        } else {
            ownKeys(Object(source)).forEach((function(key) {
                Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
            }))
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}
var viewFunction = function(_ref) {
    var fullSize = _ref.fullSize,
        _ref$props = _ref.props,
        arrowLength = _ref$props.arrowLength,
        arrowWidth = _ref$props.arrowWidth,
        border = _ref$props.border,
        canvas = _ref$props.canvas,
        color = _ref$props.color,
        cornerRadius = _ref$props.cornerRadius,
        offset = _ref$props.offset,
        text = _ref$props.text,
        x = _ref$props.x,
        y = _ref$props.y,
        size = _ref.size,
        textRef = _ref.textRef;
    var correctedCoordinates = (0, _tooltip_utils.recalculateCoordinates)({
        canvas: canvas,
        anchorX: x,
        anchorY: y,
        size: fullSize,
        offset: offset,
        arrowLength: arrowLength
    });
    var angle = (0, _tooltip_utils.getCloudAngle)(fullSize, correctedCoordinates);
    return Preact.h("g", {
        "pointer-events": "none"
    }, Preact.h(_svg_path.PathSvgElement, {
        d: (0, _tooltip_utils.getCloudPoints)(fullSize, correctedCoordinates, angle, {
            cornerRadius: cornerRadius,
            arrowWidth: arrowWidth
        }, true),
        fill: color,
        stroke: border.color,
        strokeWidth: border.width,
        transform: "rotate(".concat(angle, " ").concat(correctedCoordinates.x, " ").concat(correctedCoordinates.y, ")")
    }), Preact.h("g", {
        "text-anchor": "middle",
        ref: textRef,
        transform: "translate(".concat(correctedCoordinates.x, ", ").concat(correctedCoordinates.y - size.height / 2 - size.y, ")")
    }, Preact.h(_svg_text.TextSvgElement, {
        text: text
    })))
};
exports.viewFunction = viewFunction;
var TooltipProps = {
    color: "#fff",
    border: {
        color: "#000",
        width: 1
    },
    text: "",
    paddingLeftRight: 18,
    paddingTopBottom: 15,
    x: 0,
    y: 0,
    cornerRadius: 0,
    arrowWidth: 20,
    arrowLength: 10,
    offset: 0,
    canvas: {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
        width: 0,
        height: 0
    }
};
exports.TooltipProps = TooltipProps;

function Tooltip(props) {
    var __textRef = (0, _hooks.useRef)();
    var _useState = (0, _hooks.useState)({
            x: 0,
            y: 0,
            width: 0,
            height: 0
        }),
        _useState2 = _slicedToArray(_useState, 2),
        __state_size = _useState2[0],
        __state_setSize = _useState2[1];
    var __fullSize = (0, _hooks.useCallback)((function() {
        var paddingLeftRight = props.paddingLeftRight,
            paddingTopBottom = props.paddingTopBottom;
        return {
            width: __state_size.width + 2 * paddingLeftRight,
            height: __state_size.height + 2 * paddingTopBottom
        }
    }), [props.paddingLeftRight, props.paddingTopBottom, __state_size]);
    var __restAttributes = (0, _hooks.useCallback)((function() {
        props.arrowLength, props.arrowWidth, props.border, props.canvas, props.color, props.cornerRadius, props.offset, props.paddingLeftRight, props.paddingTopBottom, props.text, props.x, props.y;
        var restProps = _objectWithoutProperties(props, ["arrowLength", "arrowWidth", "border", "canvas", "color", "cornerRadius", "offset", "paddingLeftRight", "paddingTopBottom", "text", "x", "y"]);
        return restProps
    }), [props]);
    (0, _hooks.useEffect)((function() {
        __state_setSize((function(__state_size) {
            return __textRef.current.getBBox()
        }))
    }), []);
    return viewFunction({
        props: _objectSpread({}, props),
        size: __state_size,
        textRef: __textRef,
        fullSize: __fullSize(),
        restAttributes: __restAttributes()
    })
}
Tooltip.defaultProps = _objectSpread({}, TooltipProps);
