/**
 * DevExtreme (renovation/viz/core/utils.js)
 * Version: 21.1.0 (build 20350-0313)
 * Build date: Tue Dec 15 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.getElementWidth = getElementWidth;
exports.getElementHeight = getElementHeight;
exports.mergeRtlEnabled = exports.pickPositiveValue = exports.sizeIsValid = void 0;
var _config = _interopRequireDefault(require("../../../core/config"));
var _get_computed_style = _interopRequireDefault(require("../../ui/pager/utils/get_computed_style"));
var _get_element_width = require("../../ui/pager/utils/get_element_width");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function getElementWidth(element) {
    var style = (0, _get_computed_style.default)(element);
    return (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.width) - (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.paddingLeft) - (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.paddingRight)
}

function getElementHeight(element) {
    var style = (0, _get_computed_style.default)(element);
    return (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.height) - (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.paddingTop) - (0, _get_element_width.toNumber)(null === style || void 0 === style ? void 0 : style.paddingBottom)
}
var sizeIsValid = function(value) {
    return !!(null !== value && void 0 !== value ? value : value > 0)
};
exports.sizeIsValid = sizeIsValid;
var pickPositiveValue = function(values) {
    return values.reduce((function(result, value) {
        return value > 0 && !result ? value : result
    }), 0)
};
exports.pickPositiveValue = pickPositiveValue;
var mergeRtlEnabled = function(rtlProp, config) {
    if (void 0 !== rtlProp) {
        return rtlProp
    }
    if (void 0 !== (null === config || void 0 === config ? void 0 : config.rtlEnabled)) {
        return config.rtlEnabled
    }
    return (0, _config.default)().rtlEnabled
};
exports.mergeRtlEnabled = mergeRtlEnabled;
